-- ====================================================================
--                  Procedimento para atualizar estoque
--                  ------------ ---- --------- -------
--
--  Parmetros: P_FILIMOVI   = Cdigo da filial a ser considerada.
--              P_DTINICIAL  = Data inicial para clculo de estoque.
--              P_DTFINAL    = Data final para clculo de estoque.
--              P_FILILANCTO = Cdigo da filial de lanamento.
--              P_NRLANCTO   = Nmero de um lanamento (Opcional).
--              P_CDPRODUTO  = Cdigo do produto a ser evoludo (Opcional).
--
--
-- @C:\Web_501\Sql\End_Conv\Oracle\4020_ESTSTPO_Atualiza_Estoque_REC.SQL
-- raise_application_error(-20501, '' , True);
-- ====================================================================
CREATE OR REPLACE PROCEDURE ATUALIZA_ESTOQUE_REC(
   P_FILIMOVI   IN ITLANCTOEST.CDFILIMOVI%TYPE,
   P_DTINICIAL  IN ITLANCTOEST.DTLANCMOVI%TYPE,
   P_DTFINAL    IN ITLANCTOEST.DTLANCMOVI%TYPE,
   P_FILILANCTO IN ITLANCTOEST.CDFILIAL%TYPE,
   P_NRLANCTO   IN ITLANCTOEST.NRLANCESTQ%TYPE DEFAULT NULL)
AS

BEGIN

   DECLARE

      V_FILIAUX       VARCHAR2(04);
      V_IDESTONEG     VARCHAR2(04);
      V_DTINICIAL     DATE;
      V_DTINICAUX     DATE;
      V_DTINICEST     DATE;
      V_DTINICPOS     DATE;
      V_DTFINAL       DATE;
      V_COUNTPOS      NUMBER;
      V_QTDEESTO      NUMBER;
      V_VALRESTO      NUMBER;
      V_VALRBRUT      NUMBER;
      V_VALRESTOM1    NUMBER;
      V_VALRBRUTM1    NUMBER;
      V_VALRESTOM2    NUMBER;
      V_VALRBRUTM2    NUMBER;
      V_QTDEANTE      NUMBER;
      V_VRESTANT      NUMBER;
      V_VRBRUANT      NUMBER;
      V_VRESTANTM1    NUMBER;
      V_VRBRUANTM1    NUMBER;
      V_VRESTANTM2    NUMBER;
      V_VRBRUANTM2    NUMBER;
      V_QTDEESTOPOS   NUMBER;
      V_VALRESTOPOS   NUMBER;
      V_VALRBRUTPOS   NUMBER;
      V_VALRESTOPOSM1 NUMBER;
      V_VALRBRUTPOSM1 NUMBER;
      V_VALRESTOPOSM2 NUMBER;
      V_VALRBRUTPOSM2 NUMBER;
      V_QTDEANTEPOS   NUMBER;
      V_VRESTANTPOS   NUMBER;
      V_VRBRUANTPOS   NUMBER;
      V_VRESTANTPOSM1 NUMBER;
      V_VRBRUANTPOSM1 NUMBER;
      V_VRESTANTPOSM2 NUMBER;
      V_VRBRUANTPOSM2 NUMBER;
      V_VRINDICE1     NUMBER;
      V_VRINDICE2     NUMBER;
      V_QTRESPRODPED  NUMBER;
      V_CUSTPROD      NUMBER;

      V_DTSALDO       DATE;
      V_EXISMOV       VARCHAR2(01);
      V_POSIZERO      VARCHAR2(01);
      V_DTPOSIESTQ    DATE;
      V_NRLANCESTQ    VARCHAR2(14);
      V_DTRECALCEST   DATE;
      V_DTAUXILIAR    DATE;

      V_CDINDICEMF    VARCHAR2(04);
      V_CDINDICEMF2   VARCHAR2(04);

      V_CDTPINDICE    VARCHAR2(01);
      V_IDPERVALOR    VARCHAR2(01);
      V_CDTPINDICE2   VARCHAR2(01);
      V_IDPERVALOR2   VARCHAR2(01);
      V_CDPRODUTO     VARCHAR2(10);
      V_MOVNEG        VARCHAR2(01);      

/*VARIVEIS PARA CALCULO DO CUSTO LOGISTICO*/

      V_VRCLOGDIAANT    NUMBER;
      V_VRSEGUDIAANT    NUMBER;
      V_VRCUSTOLOG      NUMBER;
      V_VRCUSTOSEG      NUMBER;
      V_VRCLOGDIAAM1    NUMBER;
      V_VRCLOGDIAAM2    NUMBER;
      V_VRSEGUDIAAM1    NUMBER;
      V_VRSEGUDIAAM2    NUMBER;
      V_VRCLOGDIAM1     NUMBER;
      V_VRCLOGDIAM2     NUMBER;
      V_VRSEGUDIAM1     NUMBER;
      V_VRSEGUDIAM2     NUMBER;
      V_CDFORNECED      VARCHAR2(21);
      V_VRCUSTOLOGPOS   NUMBER;
      V_VRCUSTOSEGPOS   NUMBER;

      V_VRCUSTLOGLAN    NUMBER;
      V_VRSEGULOGLAN    NUMBER;

      V_UTILLOTE        CHAR;
      V_UTILALMO        CHAR;

      V_NRLISTA         VARCHAR2(20);
      V_NRLISTADT       VARCHAR2(20);

      -- variveis host
      wRowId_POSESTDIA         RowId;
      wRowId_PRODLCESTOQ       RowId;

      w_S                      CHAR(1) := 'S';
      w_N                      CHAR(1) := 'N';

      wCt                      INTEGER := 0;
      wCt_Tables               VARCHAR2(100);

      V_DTENTRSAIDANT           DATE;  /*Data anterior da NF*/
      V_DTLANCMOVANT            DATE;  /*Data anterior do Item na Itlanctoest*/
      V_DATAPOS                 DATE; /*Variavel auxiliar*/
      V_DTULTMOVIMEN            DATE; /*Variavel auxiliar*/

      V_QTESTQDIAENTR     NUMBER;
      V_QTESTQDIASAID     NUMBER;
      V_QTESTQDIARETI     NUMBER;
      V_QTESTQDIADEVO     NUMBER;
      V_QTESTQDIAIMPI     NUMBER;
      V_QTESTQDIAIMPF     NUMBER;
      V_QTESTQDIAAJUI     NUMBER;
      V_QTESTQDIAAJUF     NUMBER;

      V_VRESTQDIAENTR     NUMBER;
      V_VRESTQDIASAID     NUMBER;
      V_VRESTQDIARETI     NUMBER;
      V_VRESTQDIADEVO     NUMBER;
      V_VRESTQBRUDEVO     NUMBER;
      V_VRESTQDIAIMPI     NUMBER;
      V_VRESTQDIAIMPF     NUMBER;
      V_VRESTQDIAAJUI     NUMBER;
      V_VRESTQDIAAJUF     NUMBER;

      V_VRESTQBRUIMPI     NUMBER;
      V_VRESTQBRUIMPF     NUMBER;
      V_VRESTQBRUAJUI     NUMBER;
      V_VRESTQBRUAJUF     NUMBER;

      V_QTESTQANTENTR     NUMBER;
      V_QTESTQANTSAID     NUMBER;
      V_QTESTQANTRETI     NUMBER;
      V_QTESTQANTDEVO     NUMBER;
      V_QTESTQANTIMPI     NUMBER;
      V_QTESTQANTIMPF     NUMBER;
      V_QTESTQANTAJUI     NUMBER;
      V_QTESTQANTAJUF     NUMBER;

      V_VRESTQANTENTR     NUMBER;
      V_VRESTQANTSAID     NUMBER;
      V_VRESTQANTRETI     NUMBER;
      V_VRESTQANTDEVO     NUMBER;
      V_VRESTQANTIMPI     NUMBER;
      V_VRESTQANTIMPF     NUMBER;
      V_VRESTQANTAJUI     NUMBER;
      V_VRESTQANTAJUF     NUMBER;
      V_VRESTBRUTENTR     NUMBER;
      V_VRBRUTDIASAID     NUMBER;
      V_DTLANCTOEST       DATE;
      V_PRIM              CHAR;
      V_QTDEANTULTE       NUMBER;
      V_VRESTANTULT       NUMBER;
      V_VRBRUANTULT       NUMBER;

      CURSOR C_MOVILOTE IS
         SELECT M.CDFILIAL, M.CDALMOXARIFE, M.CDLOCALESTOQ,
                M.NRLOTEESTQ, M.NRSUBLOTE, M.CDPRODUTO, M.RowId
         FROM MOVILOTE M
         WHERE M.NRMOVILOTE   = P_FILILANCTO || P_NRLANCTO
         UNION
         SELECT M.CDFILIAL, M.CDALMOXARIFE, M.CDLOCALESTOQ,
                M.NRLOTEESTQ, M.NRSUBLOTE, M.CDPRODUTO, M.RowId
         FROM MOVILOTE M
         WHERE M.NRLANCTOORIG = P_FILILANCTO || P_NRLANCTO

         ORDER BY CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO;

   BEGIN

      BEGIN
         SELECT NVL(CDTPINDICE,'1'),  NVL(IDPERVALOR,'2'),  CDINDICEMF,
                NVL(CDTPINDICE2,'1'), NVL(IDPERVALOR2,'2'), CDINDICEMF2
         INTO V_CDTPINDICE,  V_IDPERVALOR,  V_CDINDICEMF,
              V_CDTPINDICE2, V_IDPERVALOR2, V_CDINDICEMF2
         FROM PARAMGERAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_CDTPINDICE  := Null;  V_IDPERVALOR  := Null;  V_CDINDICEMF   := Null;
            V_CDTPINDICE2 := Null;  V_IDPERVALOR2 := Null;   V_CDINDICEMF2 := NULL;
         END;
      END;

      V_CDPRODUTO := 'X';

      SELECT MAX(NVL(IDUTILLOTE,'N')),
             MAX(NVL(IDUTILALMOX,'N'))
      INTO V_UTILLOTE,
           V_UTILALMO
      FROM PARAMFILIAL
      WHERE CDFILIAL = P_FILIMOVI;

      /*Gera um nmero randomico para chave da tabela lista que recebe os itens
        atualizados, para posterior atualizao da POSESTCONS*/

      SELECT LPAD(ABS(ROUND(DBMS_RANDOM.VALUE(9999,9999999999))),10,'0')
      INTO V_NRLISTA
      FROM DUAL;

      /*Gera um nmero randomico para chave da tabela lista que recebe as datas
       para atualizao, para posterior atualizao da POSESTCONS*/

      SELECT LPAD(ABS(ROUND(DBMS_RANDOM.VALUE(9999,9999999999))),10,'0')
      INTO V_NRLISTADT
      FROM DUAL;

      /* LER OS PRODUTOS QUE SERO ATUALIZADOS  */
      FOR C_PRODUTO IN C_MOVILOTE LOOP

         IF V_CDPRODUTO = 'X' THEN
            V_CDPRODUTO := C_PRODUTO.CDPRODUTO;

            INSERT INTO LISTA
              (NRLISTA, CDLISTA)
            VALUES
              (V_NRLISTA, V_CDPRODUTO);
         END IF;

         IF V_CDPRODUTO <> C_PRODUTO.CDPRODUTO THEN

            IF (NVL(V_UTILALMO,w_N) = w_S) OR  (NVL(V_UTILLOTE, w_N) = w_S) THEN
               ATUALIZA_ESTOQUE_CONS(P_FILIMOVI, V_CDPRODUTO, P_DTINICIAL, P_DTFINAL);
               V_CDPRODUTO := C_PRODUTO.CDPRODUTO;
            ELSE
               V_CDPRODUTO := C_PRODUTO.CDPRODUTO;
               INSERT INTO LISTA
                 (NRLISTA, CDLISTA)
               VALUES
                 (V_NRLISTA, V_CDPRODUTO);
            END IF;
         END IF;

         BEGIN
           SELECT DTRECALCEST, CDFILIAL, Rowid
           INTO V_DTRECALCEST, V_FILIAUX, wRowId_PRODLCESTOQ
           FROM PRODLCESTOQ
           WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)     AND
                 (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
                 (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
                 (CDPRODUTO    = C_PRODUTO.CDPRODUTO)
           FOR UPDATE;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTRECALCEST := Null; V_FILIAUX := Null; wRowId_PRODLCESTOQ := Null;
         END;

        /* ATUALIZA AS DATAS INICIAL/FINAL PARA ATUALIZAR TODO PERODO */

         SELECT MIN(DTLANCMOVI) INTO V_DTINICEST
         FROM ITLANCTOEST
         WHERE (CDFILIMOVI   = C_PRODUTO.CDFILIAL)     AND
               (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
               (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
               (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
               (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
               (CDPRODMOVI   = C_PRODUTO.CDPRODUTO);

         SELECT MIN(DTPOSIESTQ) INTO V_DTINICPOS
         FROM POSESTDIA
         WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)     AND
               (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
               (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
               (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
               (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
               (CDPRODUTO    = C_PRODUTO.CDPRODUTO);

         /* DATA INICIAL */

         IF NOT(V_DTRECALCEST IS NULL) AND
            (V_DTRECALCEST < P_DTINICIAL) THEN
            V_DTINICIAL := V_DTRECALCEST;
         ELSE
            V_DTINICIAL := P_DTINICIAL;
         END IF;

         IF NOT(V_DTINICEST IS NULL) OR
            NOT(V_DTINICPOS IS NULL) THEN

            IF NOT(V_DTINICEST IS NULL) THEN
               V_DTINICAUX := V_DTINICEST;
            END IF;

            IF NOT(V_DTINICPOS IS NULL) THEN
               IF (V_DTINICPOS < V_DTINICAUX) THEN
                   V_DTINICAUX := V_DTINICPOS;
               END IF;
            END IF;

            IF (V_DTINICIAL < V_DTINICAUX) THEN
                V_DTINICIAL := V_DTINICAUX;
            END IF;

            DELETE POSESTDIA
            WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)     AND
                  (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
                  (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
                  (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
                  (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
                  (CDPRODUTO    = C_PRODUTO.CDPRODUTO)    AND
                  (DTPOSIESTQ  <= V_DTINICEST);
         END IF;

         /* DATA FINAL */
         SELECT MAX(DTLANCMOVI) INTO V_DTFINAL
         FROM ITLANCTOEST
         WHERE (CDFILIMOVI   = C_PRODUTO.CDFILIAL)     AND
               (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
               (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
               (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
               (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
               (CDPRODMOVI   = C_PRODUTO.CDPRODUTO);

         IF V_DTFINAL IS NULL THEN
            V_DTFINAL := P_DTFINAL;
         ELSE
            IF (V_DTFINAL <= P_DTFINAL) THEN
                V_DTFINAL := P_DTFINAL;
            END IF;
         END IF;

         /* LER SALDO INICIAL DO PRODUTO */

         BEGIN
           SELECT ROUND(NVL(QTESTOQDIA,   0), 5),
                  ROUND(NVL(VRESTOQDIA,   0), 5),
                  ROUND(NVL(VRESTOQBRUT,  0), 5),
                  ROUND(NVL(VRESTOQDIAM1, 0), 5),
                  ROUND(NVL(VRESTOQBRUM1, 0), 5),
                  ROUND(NVL(VRESTOQDIAM2, 0), 5),
                  ROUND(NVL(VRESTOQBRUM2, 0), 5),
                  ROUND(NVL(QTESTOQANT,   0), 5),
                  ROUND(NVL(VRESTOQANT,   0), 5),
                  ROUND(NVL(VRBRUTOANT,   0), 5),
                  ROUND(NVL(VRESTOQANTM1, 0), 5),
                  ROUND(NVL(VRBRUTOANTM1, 0), 5),
                  ROUND(NVL(VRESTOQANTM2, 0), 5),
                  ROUND(NVL(VRBRUTOANTM2, 0), 5),
                  DTPOSIESTQ,
                  ROUND(NVL(VRCLOGDIAANT,0),5) ,
                  ROUND(NVL(VRSEGUDIAANT,0),5),
                  ROUND(NVL(VRCLOGDIAAM1,0),5) ,
                  ROUND(NVL(VRCLOGDIAAM2,0),5),
                  ROUND(NVL(VRSEGUDIAAM1,0),5) ,
                  ROUND(NVL(VRSEGUDIAAM2,0),5),
                  ROUND(NVL(VRCLOGDIA,0),5) ,
                  ROUND(NVL(VRSEGUDIA,0),5),
                  ROUND(NVL(VRCLOGDIAM1,0),5) ,
                  ROUND(NVL(VRCLOGDIAM2,0),5),
                  ROUND(NVL(VRSEGUDIAM1,0),5) ,
                  ROUND(NVL(VRSEGUDIAM2,0),5)
           INTO   V_QTDEESTOPOS,
                  V_VALRESTOPOS,
                  V_VALRBRUTPOS,
                  V_VALRESTOPOSM1,
                  V_VALRBRUTPOSM1,
                  V_VALRESTOPOSM2,
                  V_VALRBRUTPOSM2,
                  V_QTDEANTEPOS,
                  V_VRESTANTPOS,
                  V_VRBRUANTPOS,
                  V_VRESTANTPOSM1,
                  V_VRBRUANTPOSM1,
                  V_VRESTANTPOSM2,
                  V_VRBRUANTPOSM2,
                  V_DTAUXILIAR,
                  V_VRCLOGDIAANT,
                  V_VRSEGUDIAANT,
                  V_VRCLOGDIAAM1,
                  V_VRCLOGDIAAM2,
                  V_VRSEGUDIAAM1,
                  V_VRSEGUDIAAM2,
                  V_VRCUSTOLOGPOS,
                  V_VRCUSTOSEGPOS,
                  V_VRCLOGDIAM1,
                  V_VRCLOGDIAM2,
                  V_VRSEGUDIAM1,
                  V_VRSEGUDIAM2
           FROM POSESTDIA
           WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)        AND
                 (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE)    AND
                 (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ)    AND
                 (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)      AND
                 (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)       AND
                 (CDPRODUTO    = C_PRODUTO.CDPRODUTO)       AND
                 (DTPOSIESTQ   = (SELECT MAX(DTPOSIESTQ)
                                  FROM POSESTDIA
                                  WHERE (CDFILIAL     =  C_PRODUTO.CDFILIAL)     AND
                                        (CDALMOXARIFE =  C_PRODUTO.CDALMOXARIFE) AND
                                        (CDLOCALESTOQ =  C_PRODUTO.CDLOCALESTOQ) AND
                                        (NRLOTEESTQ   =  C_PRODUTO.NRLOTEESTQ)   AND
                                        (NRSUBLOTE    =  C_PRODUTO.NRSUBLOTE)    AND
                                        (CDPRODUTO    =  C_PRODUTO.CDPRODUTO)    AND
                                        (DTPOSIESTQ   <= V_DTINICIAL)));
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
                V_QTDEESTOPOS    := 0;
                V_VALRESTOPOS    := 0;
                V_VALRBRUTPOS    := 0;
                V_VALRESTOPOSM1  := 0;
                V_VALRBRUTPOSM1  := 0;
                V_VALRESTOPOSM2  := 0;
                V_VALRBRUTPOSM2  := 0;
                V_QTDEANTEPOS    := 0;
                V_VRESTANTPOS    := 0;
                V_VRBRUANTPOS    := 0;
                V_VRESTANTPOSM1  := 0;
                V_VRBRUANTPOSM1  := 0;
                V_VRESTANTPOSM2  := 0;
                V_VRBRUANTPOSM2  := 0;
                V_DTAUXILIAR     := Null;
                V_VRCLOGDIAANT   := 0;
                V_VRSEGUDIAANT   := 0;
                V_VRCLOGDIAAM1   := 0;
                V_VRCLOGDIAAM2   := 0;
                V_VRSEGUDIAAM1   := 0;
                V_VRSEGUDIAAM2   := 0;
                V_VRCUSTOLOGPOS  := 0;
                V_VRCUSTOSEGPOS  := 0;
                V_VRCLOGDIAM1    := 0;
                V_VRCLOGDIAM2    := 0;
                V_VRSEGUDIAM1    := 0;
                V_VRSEGUDIAM2    := 0;
         END;

         DELETE POSESTATU
         WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)     AND
               (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
               (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
               (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
               (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
               (CDPRODUTO    = C_PRODUTO.CDPRODUTO);

         DELETE POSESTDIA
         WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)     AND
               (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
               (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
               (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
               (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
               (CDPRODUTO    = C_PRODUTO.CDPRODUTO)    AND
               (DTPOSIESTQ   > V_DTINICIAL);

         /* ATUALIZA SALDO DE ESTOQUE DESDE A DATA INICIAL */
         /* AT A DATA DE PROCESSAMENTO                    */

         V_EXISMOV    := w_N;
         V_DTSALDO    := V_DTINICIAL+1;
         V_NRLANCESTQ := 'X';
         IF (V_DTSALDO  <> V_DTAUXILIAR)  THEN
            V_QTDEESTO   := V_QTDEESTOPOS;
            V_VALRESTO   := V_VALRESTOPOS;
            V_VALRBRUT   := V_VALRBRUTPOS;
            V_VALRESTOM1 := V_VALRESTOPOSM1;
            V_VALRBRUTM1 := V_VALRBRUTPOSM1;
            V_VALRESTOM2 := V_VALRESTOPOSM2;
            V_VALRBRUTM2 := V_VALRBRUTPOSM2;
         ELSE
            V_QTDEESTO   :=  V_QTDEANTEPOS;
            V_VALRESTO   :=  V_VRESTANTPOS;
            V_VALRBRUT   :=  V_VRBRUANTPOS;
            V_VALRESTOM1 :=  V_VRESTANTPOSM1;
            V_VALRBRUTM1 :=  V_VRBRUANTPOSM1;
            V_VALRESTOM2 :=  V_VRESTANTPOSM2;
            V_VALRBRUTM2 :=  V_VRBRUANTPOSM2;
         END IF;

         V_QTDEANTULTE   := V_QTDEANTEPOS;
         V_VRESTANTULT   := V_VRESTANTPOS;
         V_VRBRUANTULT   := V_VRBRUANTPOS;

         V_QTDEANTE   := V_QTDEESTO;
         V_VRESTANT   := V_VALRESTO;
         V_VRBRUANT   := V_VALRBRUT;
         V_VRESTANTM1 := V_VALRESTOM1;
         V_VRBRUANTM1 := V_VALRBRUTM1;
         V_VRESTANTM2 := V_VALRESTOM2;
         V_VRBRUANTM2 := V_VALRBRUTM2;
         V_VRCUSTOLOG := V_VRCUSTOLOGPOS;
         V_VRCUSTOSEG := V_VRCUSTOSEGPOS;

         IF V_VRCUSTOLOG <> 0 THEN
            V_VRCLOGDIAANT  := V_VRCUSTOLOG;
         END IF;

         IF V_VRCUSTOSEG <> 0 THEN
            V_VRSEGUDIAANT := V_VRCUSTOSEG;
         END IF;


         V_MOVNEG := w_N;

         V_DTLANCTOEST := V_DTINICIAL;

         V_QTESTQDIAENTR  := 0;  V_VRESTQDIAENTR := 0;  V_VRESTBRUTENTR := 0;
         V_QTESTQDIAIMPI  := 0;  V_VRESTQDIASAID := 0;  V_VRESTQBRUIMPI := 0;
         V_QTESTQDIAIMPF  := 0;  V_VRESTQDIARETI := 0;  V_VRESTQBRUAJUI := 0;
         V_QTESTQDIAAJUI  := 0;  V_VRESTQDIADEVO := 0;
         V_QTESTQDIAAJUF  := 0;  V_VRESTQDIAIMPI := 0;
         V_QTESTQDIASAID  := 0;  V_VRESTQDIAIMPF := 0;
         V_QTESTQDIARETI  := 0;  V_VRESTQDIAAJUI := 0;
         V_QTESTQDIADEVO  := 0;  V_VRESTQDIAAJUF := 0;

         V_PRIM := 'S';
         FOR C_LANCTOEST IN (SELECT IDTIPOMOVI, DTLANCMOVI, NVL(VRLANCTOEST,0) VRLANCTOEST,
                                    NVL(VRLANCTOBRUT, 0) VRLANCTOBRUT, QTLANCTOEST, IDALTCMEDMV,
                                    CDFILIAL, NRLANCESTQ, VRCUSTLOGLAN, VRSEGULOGLAN, NRSEQUITEM,
                                    NVL(IDORDEMCLC,IDTIPOMOVI) IDORDEMCLC
                             FROM ITLANCTOEST
                             WHERE (CDFILIMOVI   = C_PRODUTO.CDFILIAL)     AND
                                   (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
                                   (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
                                   (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
                                   (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
                                   (CDPRODMOVI   = C_PRODUTO.CDPRODUTO)    AND
/*O between foi alterado devido a problema no select na coan- gerao de nf por romaneio sem o */
                                   (DTLANCMOVI   BETWEEN TO_CHAR(V_DTINICIAL,'DD/MM/YYYY')  AND TO_CHAR(V_DTFINAL,'DD/MM/YYYY'))  AND
                                   (NVL(IDEVOLESTOQ,w_S) = w_S)
                             ORDER BY DTLANCMOVI, NVL(IDORDEMCLC,IDTIPOMOVI), NRLANCESTQ, NRSEQUITEM) LOOP


            IF (C_LANCTOEST.DTLANCMOVI <> V_DTLANCTOEST) AND (V_PRIM <> 'S') THEN

               V_QTESTQDIAENTR  := 0;  V_VRESTQDIAENTR := 0;
               V_QTESTQDIAIMPI  := 0;  V_VRESTQDIASAID := 0;
               V_QTESTQDIAIMPF  := 0;  V_VRESTQDIARETI := 0;
               V_QTESTQDIAAJUI  := 0;  V_VRESTQDIADEVO := 0;
               V_QTESTQDIAAJUF  := 0;  V_VRESTQDIAIMPI := 0;
               V_QTESTQDIASAID  := 0;  V_VRESTQDIAIMPF := 0;
               V_QTESTQDIARETI  := 0;  V_VRESTQDIAAJUI := 0;
               V_QTESTQDIADEVO  := 0;  V_VRESTQDIAAJUF := 0;
               V_VRESTBRUTENTR  := 0;
               V_VRESTQBRUIMPI  := 0;
               V_VRESTQBRUAJUI  := 0;

               V_DTLANCTOEST := C_LANCTOEST.DTLANCMOVI;

               V_QTDEANTEPOS    := V_QTDEANTE;
               V_VRESTANTPOS    := V_VRESTANT;
               V_VRBRUANTPOS    := V_VRBRUANT;
               V_VRESTANTPOSM1  := V_VRESTANTM1;
               V_VRBRUANTPOSM1  := V_VRBRUANTM1;
               V_VRESTANTPOSM2  := V_VRESTANTM2;
               V_VRBRUANTPOSM2  := V_VRBRUANTM2;

               IF V_QTDEANTE <> 0 THEN
                  V_QTDEANTULTE   := V_QTDEANTE;
                  V_VRESTANTULT   := V_VRESTANT;
                  V_VRBRUANTULT   := V_VRBRUANT;
               END IF;

            END IF;

            IF (P_FILILANCTO = C_LANCTOEST.CDFILIAL) AND (P_NRLANCTO = C_LANCTOEST.NRLANCESTQ) THEN

               BEGIN
                  /*CARREGADA DATA ANTERIOR DA NF E DO ITEM EM ESTOQUE*/
                  SELECT DTENTRSAIDANT, DTLANCMOVANT
                  INTO V_DTENTRSAIDANT, V_DTLANCMOVANT
                  FROM NOTAFISCAL N, LANCTOESTOQ L, ITLANCTOEST I
                  WHERE
                     L.CDFILIAL     = N.CDFILIAL               AND
                     L.NRLANCTONF   = N.NRLANCTONF             AND
                     L.CDFILIAL     = C_LANCTOEST.CDFILIAL     AND
                     L.NRLANCESTQ   = C_LANCTOEST.NRLANCESTQ   AND
                     L.CDFILIAL     = I.CDFILIAL               AND
                     L.NRLANCESTQ   = I.NRLANCESTQ             AND
                     I.NRSEQUITEM   = C_LANCTOEST.NRSEQUITEM;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_DTENTRSAIDANT   := NULL;
                     V_DTLANCMOVANT    := NULL;
               END;

               /*INSERE  DATA ATUAL DO LANAMENTO E DATAS ANTERIORES DA NOTAFISCAL E
                 DO ITEM EM ESTOQUE, EM UMA LISTA PARA POSTERIOR ATUALIZAO DA
                 POSESTCONS*/

               IF NOT C_LANCTOEST.DTLANCMOVI IS NULL THEN
                  INSERT INTO LISTA(NRLISTA, CDLISTA)
                  (SELECT V_NRLISTADT, LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(C_LANCTOEST.DTLANCMOVI+1)
                   FROM DUAL
                   MINUS
                   SELECT NRLISTA, LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(C_LANCTOEST.DTLANCMOVI+1)
                   FROM LISTA
                   WHERE NRLISTA = V_NRLISTADT  AND
                         CDLISTA = LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(C_LANCTOEST.DTLANCMOVI+1));
               END IF;

               IF NOT V_DTLANCMOVANT IS NULL THEN
                  INSERT INTO LISTA(NRLISTA, CDLISTA)
                  (SELECT V_NRLISTADT, LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(V_DTLANCMOVANT+1)
                   FROM DUAL
                   MINUS
                   SELECT NRLISTA, LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(V_DTLANCMOVANT+1)
                   FROM LISTA
                   WHERE NRLISTA = V_NRLISTADT  AND
                         CDLISTA = LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(V_DTLANCMOVANT+1));
               END IF;


               IF NOT V_DTENTRSAIDANT IS NULL THEN
                  INSERT INTO LISTA(NRLISTA, CDLISTA)
                  (SELECT V_NRLISTADT, LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(V_DTENTRSAIDANT+1)
                   FROM DUAL
                   MINUS
                   SELECT NRLISTA, LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(V_DTENTRSAIDANT+1)
                   FROM LISTA
                   WHERE NRLISTA = V_NRLISTADT  AND
                         CDLISTA = LPAD(C_PRODUTO.CDPRODUTO,10,' ')||(V_DTENTRSAIDANT+1));
               END IF;                                                       
            END IF;

            IF (V_CDINDICEMF IS NOT NULL) THEN

               SELECT MAX(VRINDICE)
               INTO V_VRINDICE1
               FROM  INDICE I, MOVINDICE M
               WHERE I.CDTPINDICE = V_CDTPINDICE AND
                     I.IDPERVALOR = V_IDPERVALOR AND
                     I.CDINDICE   = V_CDINDICEMF AND
                     I.CDTPINDICE = M.CDTPINDICE AND
                     I.IDPERVALOR = M.IDPERVALOR AND
                     I.CDINDICE   = M.CDINDICE   AND
                     TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY') = TO_CHAR(M.DTREFIND,'DD/MM/YYYY');

               IF (NVL(V_VRINDICE1,0) = 0) THEN
                  raise_application_error(-20501, 'ndice Financeiro Parametrizado na Personalizao do Sistema no Possui valor Cadastrado para a Data '||TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY')  , True);
               END IF;
            END IF;

            IF (V_CDINDICEMF2 IS NOT NULL) THEN
               SELECT MAX(VRINDICE)
               INTO V_VRINDICE2
               FROM  INDICE I, MOVINDICE M
               WHERE I.CDTPINDICE = V_CDTPINDICE2 AND
                     I.IDPERVALOR = V_IDPERVALOR2 AND
                     I.CDINDICE   = V_CDINDICEMF2 AND
                     I.CDTPINDICE = M.CDTPINDICE AND
                     I.IDPERVALOR = M.IDPERVALOR AND
                     I.CDINDICE   = M.CDINDICE   AND
                     TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY') = TO_CHAR(M.DTREFIND,'DD/MM/YYYY');
                       
               IF (NVL(V_VRINDICE2,0) = 0) THEN
                  raise_application_error(-20501, 'ndice Financeiro Parametrizado na Personalizao do Sistema no Possui valor Cadastrado para a Data '||TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY')  , True);
               END IF;
            END IF;

            V_VRCUSTLOGLAN := NVL(C_LANCTOEST.VRCUSTLOGLAN, 0);
            V_VRSEGULOGLAN := NVL(C_LANCTOEST.VRSEGULOGLAN, 0);


            IF (V_DTSALDO > C_LANCTOEST.DTLANCMOVI) THEN
               V_DTSALDO := C_LANCTOEST.DTLANCMOVI + 1;
            END IF;

            IF (C_LANCTOEST.DTLANCMOVI + 1) = V_DTAUXILIAR THEN
               V_QTDEESTO   := 0;
               V_VALRESTO   := 0;
               V_VALRBRUT   := 0;
               V_QTDEANTE   := 0;
               V_VRESTANT   := 0;
               V_VRBRUANT   := 0;

               V_VRESTANTM1 := 0;
               V_VRBRUANTM1 := 0;
               V_VRESTANTM2 := 0;
               V_VRBRUANTM2 := 0;

               V_VRCUSTOLOG   := 0;                /*AQUI*/
               V_VRCUSTOSEG   := 0;
               V_VRCLOGDIAANT := 0;
               V_VRSEGUDIAANT := 0;
            END IF;

            V_EXISMOV := 'S';

            /* GRAVAO DOS SALDOS DIRIOS PARA O PRODUTO */

            /* TRATAMENTO PARA CADA REGISTRO DE LANAMENTO DE ESTOQUE */

            IF (C_LANCTOEST.IDTIPOMOVI = '0') THEN    /* IMPLANTAO */
               IF V_NRLANCESTQ <> C_LANCTOEST.CDFILIAL||C_LANCTOEST.NRLANCESTQ THEN
                  V_VALRBRUT    := C_LANCTOEST.VRLANCTOBRUT;
                  V_VALRESTO    := C_LANCTOEST.VRLANCTOEST;
                  V_QTDEESTO    := C_LANCTOEST.QTLANCTOEST;
               ELSE
                  V_VALRBRUT    := V_VALRBRUT   + C_LANCTOEST.VRLANCTOBRUT;
                  V_VALRESTO    := V_VALRESTO   + C_LANCTOEST.VRLANCTOEST;
                  V_QTDEESTO    := V_QTDEESTO   + C_LANCTOEST.QTLANCTOEST;
               END IF;
               V_VRCUSTOLOG   := 0;                /*AQUI*/
               V_VRCUSTOSEG   := 0;

               IF  C_LANCTOEST.IDORDEMCLC =   'U' THEN
                  V_VRESTQDIAIMPF   := C_LANCTOEST.VRLANCTOEST;
                  V_VRESTQBRUIMPF   := C_LANCTOEST.VRLANCTOBRUT;
                  V_QTESTQDIAIMPF   := C_LANCTOEST.QTLANCTOEST;
               ELSE
                  V_VRESTQDIAIMPI   := C_LANCTOEST.VRLANCTOEST;
                  V_VRESTQBRUIMPI   := C_LANCTOEST.VRLANCTOBRUT;
                  V_QTESTQDIAIMPI   := C_LANCTOEST.QTLANCTOEST;
               END IF;
            ELSIF (C_LANCTOEST.IDTIPOMOVI = '1') THEN    /* AJUSTES     */
               IF NVL(C_LANCTOEST.IDALTCMEDMV,w_N) <> 'S' THEN
                  IF V_QTDEESTO = 0 THEN
                     IF V_QTDEANTE <> 0 THEN
                        IF (C_LANCTOEST.QTLANCTOEST <> 0) THEN
                           V_VALRBRUT := (V_VRBRUANT/V_QTDEANTE)*C_LANCTOEST.QTLANCTOEST;
                           V_VALRESTO := (V_VRESTANT /V_QTDEANTE)*C_LANCTOEST.QTLANCTOEST;

                           IF V_QTDEANTE > C_LANCTOEST.QTLANCTOEST THEN
                              V_VRCUSTOLOG := V_VRCUSTOLOG - ((V_VRCUSTOLOG/V_QTDEANTE) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTE));
                              V_VRCUSTOSEG := V_VRCUSTOSEG - ((V_VRCUSTOSEG/V_QTDEANTE) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTE));
                           ELSE
                              IF V_QTDEANTE > C_LANCTOEST.QTLANCTOEST THEN
                                 V_VRCUSTOLOG := V_VRCUSTOLOG + ((V_VRCUSTOLOG/V_QTDEANTE) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTE));
                                 V_VRCUSTOSEG := V_VRCUSTOSEG + ((V_VRCUSTOSEG/V_QTDEANTE) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTE));
                              END IF;
                           END IF;
                           V_VRBRUANT := 0;
                           V_VRESTANT := 0;
                           V_QTDEANTE := 0;

                           V_VRESTANTM1 := 0;
                           V_VRBRUANTM1 := 0;
                           V_VRESTANTM2 := 0;
                           V_VRBRUANTM2 := 0;

                           V_VRCLOGDIAANT := 0;
                           V_VRSEGUDIAANT := 0;
                        ELSE
                           V_VALRBRUT   := 0;
                           V_VALRESTO   := 0;
                        END IF;
                     ELSE
                        IF V_QTDEANTULTE  <> 0 THEN
                           IF (C_LANCTOEST.QTLANCTOEST <> 0) THEN
                              V_VALRBRUT := (V_VRBRUANTULT /V_QTDEANTULTE )*C_LANCTOEST.QTLANCTOEST;
                              V_VALRESTO := (V_VRESTANTULT/V_QTDEANTULTE )*C_LANCTOEST.QTLANCTOEST;

                              IF V_QTDEANTULTE  > C_LANCTOEST.QTLANCTOEST THEN
                                 V_VRCUSTOLOG := V_VRCUSTOLOG - ((V_VRCUSTOLOG/V_QTDEANTULTE) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTEPOS));
                                 V_VRCUSTOSEG := V_VRCUSTOSEG - ((V_VRCUSTOSEG/V_QTDEANTULTE) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTEPOS));
                              ELSE
                                 IF V_QTDEANTULTE  > C_LANCTOEST.QTLANCTOEST THEN
                                    V_VRCUSTOLOG := V_VRCUSTOLOG + ((V_VRCUSTOLOG/V_QTDEANTULTE ) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTEPOS));
                                    V_VRCUSTOSEG := V_VRCUSTOSEG + ((V_VRCUSTOSEG/V_QTDEANTULTE ) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEANTEPOS));
                                 END IF;
                              END IF;
                           ELSE
                              V_VALRBRUT   := 0;
                              V_VALRESTO   := 0;
                              V_VRBRUANT   := 0;
                              V_VRESTANT   := 0;
                              V_QTDEANTE   := 0;
                              V_VRCLOGDIAANT := 0;
                              V_VRSEGUDIAANT := 0;

                              V_VRESTANTM1 := 0;
                              V_VRBRUANTM1 := 0;
                              V_VRESTANTM2 := 0;
                              V_VRBRUANTM2 := 0;
                           END IF;
                        ELSE
                           V_VALRBRUT   := 0;
                           V_VALRESTO   := 0;
                           V_VRBRUANT   := 0;
                           V_VRESTANT   := 0;
                           V_QTDEANTE   := 0;
                           V_VRCLOGDIAANT := 0;
                           V_VRSEGUDIAANT := 0;

                           V_VRESTANTM1 := 0;
                           V_VRBRUANTM1 := 0;
                           V_VRESTANTM2 := 0;
                           V_VRBRUANTM2 := 0;
                        END IF;
                     END IF;
                     V_QTDEESTO := C_LANCTOEST.QTLANCTOEST;
                  ELSE

                     IF V_QTDEESTO > C_LANCTOEST.QTLANCTOEST THEN
                        V_VRCUSTOLOG := V_VRCUSTOLOG - ((V_VRCUSTOLOG/V_QTDEESTO) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEESTO));
                        V_VRCUSTOSEG := V_VRCUSTOSEG - ((V_VRCUSTOSEG/V_QTDEESTO) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEESTO));
                     ELSE

                        IF V_QTDEESTO < C_LANCTOEST.QTLANCTOEST THEN
                           V_VRCUSTOLOG := V_VRCUSTOLOG + ((V_VRCUSTOLOG/V_QTDEESTO) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEESTO));
                           V_VRCUSTOSEG := V_VRCUSTOSEG + ((V_VRCUSTOSEG/V_QTDEESTO) * ABS(C_LANCTOEST.QTLANCTOEST-V_QTDEESTO));
                        END IF;
                     END IF;
                     IF V_QTDEESTO <> 0 THEN
                        V_VALRBRUT := (V_VALRBRUT/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST;
                        V_VALRESTO := (V_VALRESTO/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST;
                     ELSE
                        IF V_QTDEANTULTE <> 0 THEN
                           V_VALRBRUT := (V_VRBRUANTULT /V_QTDEANTULTE )*C_LANCTOEST.QTLANCTOEST;
                           V_VALRESTO := (V_VRESTANTULT/V_QTDEANTULTE )*C_LANCTOEST.QTLANCTOEST;
                        END IF;
                     END IF;
                  END IF;
               END IF;
               V_QTDEESTO := C_LANCTOEST.QTLANCTOEST;

            ELSIF (C_LANCTOEST.IDTIPOMOVI = '2') THEN    /* ENTRADA */

               V_QTDEESTO      := V_QTDEESTO   +  C_LANCTOEST.QTLANCTOEST;

               V_QTESTQDIAENTR := V_QTESTQDIAENTR +  C_LANCTOEST.QTLANCTOEST;
               V_VRESTQDIAENTR := V_VRESTQDIAENTR + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST);
               V_VRESTBRUTENTR := V_VRESTBRUTENTR + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT);

               V_VRCUSTOLOG   := V_VRCUSTOLOG +  V_VRCUSTLOGLAN;
               V_VRCUSTOSEG   := V_VRCUSTOSEG +  V_VRSEGULOGLAN;
               IF C_LANCTOEST.QTLANCTOEST = 0 THEN
                  V_VALRBRUT := V_VALRBRUT + C_LANCTOEST.VRLANCTOBRUT;
                  V_VALRESTO := V_VALRESTO + C_LANCTOEST.VRLANCTOEST;
               ELSE
                  V_VALRBRUT := V_VALRBRUT + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT);
                  V_VALRESTO := V_VALRESTO + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST);
               END IF;

               IF V_QTDEESTO  = 0 THEN
                  V_VALRBRUT   := 0;
                  V_VALRESTO   := 0;
               END IF;
            ELSIF (C_LANCTOEST.IDTIPOMOVI = '3') THEN    /* RETIRADA    */
               IF V_QTDEESTO > 0 THEN

                  V_VRESTQDIARETI := (V_VALRESTO/V_QTDEESTO) * C_LANCTOEST.QTLANCTOEST;

                  V_VALRBRUT := V_VALRBRUT - ((V_VALRBRUT/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);
                  V_VALRESTO := V_VALRESTO - ((V_VALRESTO/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);

                  V_VRCUSTOLOG := ROUND(V_VRCUSTOLOG,8) - ROUND(((V_VRCUSTOLOG/V_QTDEESTO) *C_LANCTOEST.QTLANCTOEST),8);
                  V_VRCUSTOSEG := ROUND(V_VRCUSTOSEG,8) - ROUND(((V_VRCUSTOSEG/V_QTDEESTO) *C_LANCTOEST.QTLANCTOEST),8);

               ELSE
                  IF V_QTDEANTE > 0 THEN
                     V_VRESTQDIARETI := (V_VRESTANT/V_QTDEANTE) * C_LANCTOEST.QTLANCTOEST;
                  END IF;
               END IF;

               V_QTESTQDIARETI := C_LANCTOEST.QTLANCTOEST;
               V_QTDEESTO      := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;


               IF (V_QTDEESTO < 0) THEN
                  IF (V_QTDEANTE <> 0) THEN
                     V_VALRESTO := ((V_VRESTANT/V_QTDEANTE)*V_QTDEESTO);
                     V_VALRBRUT := ((V_VRBRUANT/V_QTDEANTE)*V_QTDEESTO);
                  ELSE
                     V_VALRESTO := 0;
                     V_VALRBRUT := 0;
                  END IF;
               END IF;

               IF ROUND(V_QTDEESTO,3) = 0 THEN
                  V_QTDEESTO := 0;
               END IF;

               IF V_QTDEESTO  = 0 THEN
                  V_VALRBRUT   := 0;
                  V_VALRESTO   := 0;
               END IF;

               IF V_QTDEESTO < 0 THEN
                  V_MOVNEG := 'S';
               END IF;
            ELSIF (C_LANCTOEST.IDTIPOMOVI = '4') THEN    /* SADA       */

               IF V_QTDEESTO > 0 THEN
                  V_VRESTQDIASAID := V_VRESTQDIASAID + ((V_VALRBRUT/V_QTDEESTO) * C_LANCTOEST.QTLANCTOEST);
                  V_VRBRUTDIASAID := V_VRBRUTDIASAID + ((V_VALRESTO/V_QTDEESTO) * C_LANCTOEST.QTLANCTOEST);

                  V_VALRBRUT   := V_VALRBRUT - ((V_VALRBRUT/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);
                  V_VALRESTO   := V_VALRESTO - ((V_VALRESTO/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);

                  V_VRCUSTOLOG := V_VRCUSTOLOG - ((V_VRCUSTOLOG/V_QTDEESTO) * C_LANCTOEST.QTLANCTOEST);
                  V_VRCUSTOSEG := V_VRCUSTOSEG - ((V_VRCUSTOSEG/V_QTDEESTO) * C_LANCTOEST.QTLANCTOEST);

               ELSE
                  IF V_QTDEANTE <> 0 THEN
                     V_VRESTQDIASAID := V_VRESTQDIASAID + ((V_VRESTANT/V_QTDEANTE) * C_LANCTOEST.QTLANCTOEST);
                     V_VRBRUTDIASAID := V_VRBRUTDIASAID + ((V_VRBRUANT/V_QTDEANTE) * C_LANCTOEST.QTLANCTOEST);
                  END IF;
               END IF;

               V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

               V_QTESTQDIASAID := V_QTESTQDIASAID + C_LANCTOEST.QTLANCTOEST;

               IF (V_QTDEESTO < 0) THEN
                  IF (V_QTDEANTE <> 0) THEN
                     V_VALRESTO := ((V_VRESTANT/V_QTDEANTE)*V_QTDEESTO);
                     V_VALRBRUT := ((V_VRBRUANT/V_QTDEANTE)*V_QTDEESTO);
                  ELSE
                     V_VALRESTO := 0;
                     V_VALRBRUT := 0;
                  END IF;
               END IF;

               IF ROUND(V_QTDEESTO,3) = 0 THEN
                  V_QTDEESTO := 0;
               END IF;

               IF V_QTDEESTO  = 0 THEN
                  V_VALRBRUT   := 0;
                  V_VALRESTO   := 0;
               END IF;

               IF V_QTDEESTO < 0 THEN
                  V_MOVNEG := 'S';
               END IF;

            ELSIF (C_LANCTOEST.IDTIPOMOVI = '5') THEN    /* DEV. FORN.  */

               IF C_LANCTOEST.QTLANCTOEST = 0 THEN
                  V_VALRBRUT := V_VALRBRUT - C_LANCTOEST.VRLANCTOBRUT;
                  V_VALRESTO := V_VALRESTO - C_LANCTOEST.VRLANCTOEST;
               ELSE
                  V_CUSTPROD := 0;
                  IF V_QTDEESTO <> 0 THEN
                     V_CUSTPROD := V_VALRBRUT / V_QTDEESTO;
                  ELSE
                     IF V_QTDEANTE <> 0 THEN
                        V_CUSTPROD := V_VRBRUANT / V_QTDEANTE;
                     END IF;
                  END IF;

                  IF (V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT)) >= 0 THEN
                     V_VALRBRUT := V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT);
                  ELSE
                     V_VALRBRUT := V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST*V_CUSTPROD);
                  END IF;

                  V_CUSTPROD := 0;
                  IF V_QTDEESTO <> 0 THEN
                     V_CUSTPROD := V_VALRESTO / V_QTDEESTO;
                  ELSE
                     IF V_QTDEANTE <> 0 THEN
                        V_CUSTPROD := V_VRESTANT / V_QTDEANTE;
                     END IF;
                  END IF;

                  IF (V_VALRESTO - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST)) >= 0 THEN
                     V_VALRESTO := V_VALRESTO - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST);
                  ELSE
                     V_VALRESTO := V_VALRESTO - (C_LANCTOEST.QTLANCTOEST*V_CUSTPROD);
                  END IF;
                  V_VRESTQDIADEVO := (C_LANCTOEST.QTLANCTOEST*V_CUSTPROD);
                  V_VRESTQBRUDEVO := (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT);
                  V_QTESTQDIADEVO := C_LANCTOEST.QTLANCTOEST;
               END IF;

               V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

               IF ROUND(V_QTDEESTO,3) = 0 THEN
                  V_QTDEESTO := 0;
               END IF;

               IF V_QTDEESTO  = 0 THEN
                  V_VALRBRUT   := 0;
                  V_VALRESTO   := 0;
               END IF;

               IF V_QTDEESTO < 0 THEN
                  V_MOVNEG := 'S';
               END IF;
            END IF;

            WHILE (V_DTSALDO <= (C_LANCTOEST.DTLANCMOVI + 1)) LOOP
               IF (V_CDINDICEMF IS NOT NULL) AND V_VRINDICE1 > 0 THEN
                  V_VALRBRUTM1  := V_VALRBRUT / V_VRINDICE1;
                  V_VALRESTOM1  := V_VALRESTO / V_VRINDICE1;
                  V_VRCLOGDIAM1 := V_VRCUSTOLOG / V_VRINDICE1;
                  V_VRSEGUDIAM1 := V_VRCUSTOSEG / V_VRINDICE1;
               END IF;

               IF (V_CDINDICEMF2 IS NOT NULL)AND V_VRINDICE2 > 0 THEN
                  V_VALRBRUTM2  := V_VALRBRUT / V_VRINDICE2;
                  V_VALRESTOM2  := V_VALRESTO / V_VRINDICE2;
                  V_VRCLOGDIAM2 := V_VRCUSTOLOG / V_VRINDICE2;
                  V_VRSEGUDIAM2 := V_VRCUSTOSEG / V_VRINDICE2;
               END IF;

               BEGIN
                 V_COUNTPOS:=1;
                 SELECT V_COUNTPOS, RowId
                 INTO V_COUNTPOS, wRowId_POSESTDIA
                 FROM POSESTDIA
                 WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)        AND
                       (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE)    AND
                       (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ)    AND
                       (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)      AND
                       (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)       AND
                       (CDPRODUTO    = C_PRODUTO.CDPRODUTO)       AND
                       (DTPOSIESTQ   = V_DTSALDO);
               EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                      V_COUNTPOS:=0;
               END;
               IF (V_COUNTPOS = 0) THEN
                  IF V_QTDEESTO = 0 THEN
                     V_POSIZERO := 'S';
                  ELSE
                     V_POSIZERO := 'N';
                  END IF;

                  IF (V_DTSALDO > C_LANCTOEST.DTLANCMOVI) THEN

                     INSERT INTO POSESTDIA
                        (CDFILIAL,     CDALMOXARIFE,  CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,   CDPRODUTO,
                         DTPOSIESTQ,   QTESTOQDIA,    VRESTOQDIA,   VRESTOQBRUT,  IDPOSIZERO,
                         QTESTOQANT,
                         VRESTOQANT,   VRBRUTOANT,
                         VRESTOQDIAM1,
                         VRESTOQBRUM1,
                         VRESTOQANTM1,
                         VRBRUTOANTM1,
                         VRESTOQDIAM2,
                         VRESTOQBRUM2,
                         VRESTOQANTM2,
                         VRBRUTOANTM2,
                         VRCLOGDIAANT, VRSEGUDIAANT,  VRCLOGDIA,    VRSEGUDIA,
                         VRCLOGDIAAM1, VRCLOGDIAAM2,  VRSEGUDIAAM1, VRSEGUDIAAM2,
                         VRCLOGDIAM1,  VRCLOGDIAM2,   VRSEGUDIAM1,  VRSEGUDIAM2,
                         ---------------------------------------------------------
                         QTESTQDIAENTR, QTESTQDIAIMPI, QTESTQDIAIMPF, QTESTQDIAAJUI, QTESTQDIAAJUF, QTESTQDIASAID,
                         QTESTQDIARETI, QTESTQDIADEVO,
                         VRESTQDIAENTR, VRESTQDIASAID, VRESTQDIARETI, VRESTQDIADEVO, VRESTQDIAIMPI, VRESTQDIAIMPF,
                         VRESTQDIAAJUI, VRESTQDIAAJUF, VRBRUTOENTR,   VRBRUTOIMPI,   VRBRUTOAJUI)
                      VALUES
                        (C_PRODUTO.CDFILIAL, C_PRODUTO.CDALMOXARIFE, C_PRODUTO.CDLOCALESTOQ, C_PRODUTO.NRLOTEESTQ,
                         C_PRODUTO.NRSUBLOTE, C_PRODUTO.CDPRODUTO, V_DTSALDO, V_QTDEESTO,  V_VALRESTO,   V_VALRBRUT ,
                         V_POSIZERO, V_QTDEANTE,   V_VRESTANT,   V_VRBRUANT,
                         V_VALRESTOPOSM1,
                         V_VALRBRUTPOSM1,
                         V_VRESTANTPOSM1,
                         V_VRBRUANTPOSM1,
                         V_VALRESTOPOSM1,
                         V_VALRBRUTPOSM1,
                         V_VRESTANTPOSM1,
                         V_VRBRUANTPOSM1,
                         V_VRCLOGDIAANT, V_VRSEGUDIAANT,  V_VRCUSTOLOG,   V_VRCUSTOSEG,
                         V_VRCLOGDIAAM1,  V_VRCLOGDIAAM2, V_VRSEGUDIAAM1, V_VRSEGUDIAAM2,
                         V_VRCLOGDIAM1,   V_VRCLOGDIAM2,  V_VRSEGUDIAM1,  V_VRSEGUDIAM2,
                         ---------------------------------------------------------
                         V_QTESTQDIAENTR, V_QTESTQDIAIMPI, V_QTESTQDIAIMPF, V_QTESTQDIAAJUI, V_QTESTQDIAAJUF, V_QTESTQDIASAID,
                         V_QTESTQDIARETI, V_QTESTQDIADEVO,
                         V_VRESTQDIAENTR, V_VRESTQDIASAID, V_VRESTQDIARETI, V_VRESTQDIADEVO, V_VRESTQDIAIMPI, V_VRESTQDIAIMPF,
                         V_VRESTQDIAAJUI, V_VRESTQDIAAJUF, V_VRESTBRUTENTR, V_VRESTQBRUIMPI, V_VRESTQBRUAJUI);

                  END IF;
               ELSE
                  IF (V_DTSALDO < (C_LANCTOEST.DTLANCMOVI + 1)) THEN
                     IF V_QTDEESTOPOS = 0 THEN
                        V_POSIZERO := 'S';
                     ELSE
                        V_POSIZERO := 'N';
                     END IF;

                     UPDATE POSESTDIA
                     SET QTESTOQDIA    = V_QTDEESTOPOS,
                         VRESTOQDIA    = V_VALRESTOPOS,
                         VRESTOQBRUT   = V_VALRBRUTPOS,
                         VRESTOQDIAM1  = V_VALRESTOPOSM1,
                         VRESTOQBRUM1  = V_VALRBRUTPOSM1,
                         VRESTOQDIAM2  = V_VALRESTOPOSM2,
                         VRESTOQBRUM2  = V_VALRBRUTPOSM2,
                         IDPOSIZERO    = V_POSIZERO,
                         QTESTOQANT    = V_QTDEANTEPOS,
                         VRESTOQANT    = V_VRESTANTPOS,
                         VRBRUTOANT    = V_VRBRUANTPOS,
                         VRESTOQANTM1  = V_VRESTANTPOSM1,
                         VRBRUTOANTM1  = V_VRBRUANTPOSM1,
                         VRESTOQANTM2  = V_VRESTANTPOSM2,
                         VRBRUTOANTM2  = V_VRBRUANTPOSM2,
                         VRCLOGDIAANT  = V_VRCLOGDIAANT,
                         VRSEGUDIAANT  = V_VRSEGUDIAANT,
                         VRCLOGDIA     = V_VRCUSTOLOGPOS,
                         VRSEGUDIA     = V_VRCUSTOSEGPOS,
                         VRCLOGDIAAM1  = V_VRCLOGDIAAM1,
                         VRCLOGDIAAM2  = V_VRCLOGDIAAM2,
                         VRSEGUDIAAM1  = V_VRSEGUDIAAM1,
                         VRSEGUDIAAM2  = V_VRSEGUDIAAM2,
                         VRCLOGDIAM1   = V_VRCLOGDIAM1,
                         VRCLOGDIAM2   = V_VRCLOGDIAM2,
                         VRSEGUDIAM1   = V_VRSEGUDIAM1,
                         VRSEGUDIAM2   = V_VRSEGUDIAM2,
                         QTESTQDIAENTR  =  V_QTESTQDIAENTR,
                         QTESTQDIAIMPI  =  V_QTESTQDIAIMPI,
                         QTESTQDIAAJUI  =  V_QTESTQDIAAJUI,
                         QTESTQDIAIMPF  =  V_QTESTQDIAIMPF,
                         QTESTQDIAAJUF  =  V_QTESTQDIAAJUF,
                         QTESTQDIASAID  =  V_QTESTQDIASAID,
                         QTESTQDIARETI  =  V_QTESTQDIARETI,
                         QTESTQDIADEVO  =  V_QTESTQDIADEVO,
                         ----------------------------------
                         VRESTQDIAENTR  =  V_VRESTQDIAENTR,
                         VRESTQDIASAID  =  V_VRESTQDIASAID,
                         VRESTQDIARETI  =  V_VRESTQDIARETI,
                         VRESTQDIADEVO  =  V_VRESTQDIADEVO,
                         VRESTQDIAIMPI  =  V_VRESTQDIAIMPI,
                         VRESTQDIAIMPF  =  V_VRESTQDIAIMPF,
                         VRESTQDIAAJUI  =  V_VRESTQDIAAJUI,
                         VRESTQDIAAJUF  =  V_VRESTQDIAAJUF,
                         VRBRUTOENTR    =  V_VRESTBRUTENTR,
                         VRBRUTOIMPI    =  V_VRESTQBRUIMPI,
                         VRBRUTOAJUI    =  V_VRESTQBRUAJUI
                     WHERE RowId = wRowId_POSESTDIA;
                  ELSE

                     IF V_QTDEESTO = 0 THEN
                        V_POSIZERO := 'S';
                     ELSE
                        V_POSIZERO := 'N';
                     END IF;
                     UPDATE POSESTDIA
                     SET QTESTOQDIA    = V_QTDEESTO,
                         VRESTOQDIA    = V_VALRESTO,
                         VRESTOQBRUT   = V_VALRBRUT,
                         VRESTOQDIAM1  = V_VALRESTOM1,
                         VRESTOQBRUM1  = V_VALRBRUTM1,
                         VRESTOQDIAM2  = V_VALRESTOM2,
                         VRESTOQBRUM2  = V_VALRBRUTM2,
                         IDPOSIZERO    = V_POSIZERO,

                         QTESTOQANT    = V_QTDEANTEPOS,
                         VRESTOQANT    = V_VRESTANTPOS,
                         VRBRUTOANT    = V_VRBRUANTPOS,
                         VRESTOQANTM1  = V_VRESTANTM1,
                         VRBRUTOANTM1  = V_VRBRUANTM1,
                         VRESTOQANTM2  = V_VRESTANTM2,
                         VRBRUTOANTM2  = V_VRBRUANTM2,
                         VRCLOGDIAANT  = V_VRCLOGDIAANT,
                         VRSEGUDIAANT  = V_VRSEGUDIAANT,
                         VRCLOGDIA     = V_VRCUSTOLOG,
                         VRSEGUDIA     = V_VRCUSTOSEG,
                         VRCLOGDIAAM1  = V_VRCLOGDIAAM1,
                         VRCLOGDIAAM2  = V_VRCLOGDIAAM2,
                         VRSEGUDIAAM1  = V_VRSEGUDIAAM1,
                         VRSEGUDIAAM2  = V_VRSEGUDIAAM2,
                         VRCLOGDIAM1   = V_VRCLOGDIAM1,
                         VRCLOGDIAM2   = V_VRCLOGDIAM2,
                         VRSEGUDIAM1   = V_VRSEGUDIAM1,
                         VRSEGUDIAM2   = V_VRSEGUDIAM2,
                         QTESTQDIAENTR  =  V_QTESTQDIAENTR,
                         QTESTQDIAIMPI  =  V_QTESTQDIAIMPI,
                         QTESTQDIAAJUI  =  V_QTESTQDIAAJUI,
                         QTESTQDIAIMPF  =  V_QTESTQDIAIMPF,
                         QTESTQDIAAJUF  =  V_QTESTQDIAAJUF,
                         QTESTQDIASAID  =  V_QTESTQDIASAID,
                         QTESTQDIARETI  =  V_QTESTQDIARETI,
                         QTESTQDIADEVO  =  V_QTESTQDIADEVO,
                         ----------------------------------
                         VRESTQDIAENTR  =  V_VRESTQDIAENTR,
                         VRESTQDIASAID  =  V_VRESTQDIASAID,
                         VRESTQDIARETI  =  V_VRESTQDIARETI,
                         VRESTQDIADEVO  =  V_VRESTQDIADEVO,
                         VRESTQDIAIMPI  =  V_VRESTQDIAIMPI,
                         VRESTQDIAIMPF  =  V_VRESTQDIAIMPF,
                         VRESTQDIAAJUI  =  V_VRESTQDIAAJUI,
                         VRESTQDIAAJUF  =  V_VRESTQDIAAJUF,
                         VRBRUTOENTR    =  V_VRESTBRUTENTR,
                         VRBRUTOIMPI    =  V_VRESTQBRUIMPI,
                         VRBRUTOAJUI    =  V_VRESTQBRUAJUI
                     WHERE RowId = wRowId_POSESTDIA;
                  END IF;
               END IF;

               V_DTSALDO  := V_DTSALDO + 1;
            END LOOP;

            /* GUARDA OS VALORES DE ESTOQUE ANTERIORES  PRXIMA MOVIMENTAO */
            V_QTDEESTOPOS   := V_QTDEESTO;
            V_VALRESTOPOS   := V_VALRESTO;
            V_VALRBRUTPOS   := V_VALRBRUT;
            V_VALRESTOPOSM1 := V_VALRESTOM1;
            V_VALRBRUTPOSM1 := V_VALRBRUTM1;
            V_VALRESTOPOSM2 := V_VALRESTOM2;
            V_VALRBRUTPOSM2 := V_VALRBRUTM2;

            V_VRCUSTOLOGPOS := V_VRCUSTOLOG;
            V_VRCUSTOSEGPOS := V_VRCUSTOSEG;

            V_NRLANCESTQ := C_LANCTOEST.CDFILIAL||C_LANCTOEST.NRLANCESTQ;
            V_PRIM       := 'N';
--            IF V_QTDEESTO <> 0 THEN
               V_QTDEANTE   := V_QTDEESTO;
               V_VRESTANT   := V_VALRESTO;
               V_VRBRUANT   := V_VALRBRUT;
               V_VRESTANTM1 := V_VALRESTOM1;
               V_VRBRUANTM1 := V_VALRBRUTM1;
               V_VRESTANTM2 := V_VALRESTOM2;
               V_VRBRUANTM2 := V_VALRBRUTM2;
               V_VRCUSTOLOG := V_VRCUSTOLOGPOS;
               V_VRCUSTOSEG := V_VRCUSTOSEGPOS;
  --          END IF;
         END LOOP;

         /* GRAVAO DOS SALDOS DIRIOS PARA O PRODUTO AT A DATA FINAL */

         UPDATE PRODLCESTOQ
         SET DTRECALCEST  = V_DTSALDO-1
         WHERE RowId = wRowId_PRODLCESTOQ;

         SELECT MAX(CDFILIAL)
         INTO V_IDESTONEG
         FROM POSESTDIA
         WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)     AND
               (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE) AND
               (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ) AND
               (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)   AND
               (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)    AND
               (CDPRODUTO    = C_PRODUTO.CDPRODUTO)    AND
               (DTPOSIESTQ   > P_DTINICIAL)            AND
               (QTESTOQDIA   < 0);

         UPDATE POSESTDIA
         SET VRESTOQDIA    = Decode(QTESTOQDIA, 0, 0, VRESTOQDIA),
             VRESTOQBRUT   = Decode(QTESTOQDIA, 0, 0, VRESTOQBRUT),
             VRESTOQDIAM1  = Decode(QTESTOQDIA, 0, 0, VRESTOQDIAM1),
             VRESTOQBRUM1  = Decode(QTESTOQDIA, 0, 0, VRESTOQBRUM1),
             VRESTOQDIAM2  = Decode(QTESTOQDIA, 0, 0, VRESTOQDIAM2),
             VRESTOQBRUM2  = Decode(QTESTOQDIA, 0, 0, VRESTOQBRUM2),
             VRCLOGDIAM1   = Decode(QTESTOQDIA, 0, 0, VRCLOGDIAM1),
             VRCLOGDIAM2   = Decode(QTESTOQDIA, 0, 0, VRCLOGDIAM2),
             VRSEGUDIAM1   = Decode(QTESTOQDIA, 0, 0, VRSEGUDIAM1),
             VRSEGUDIAM2   = Decode(QTESTOQDIA, 0, 0, VRSEGUDIAM2),
             --
             VRESTOQANT    = Decode(QTESTOQANT, 0, 0, VRESTOQANT),
             VRESTOQANTM1  = Decode(QTESTOQANT, 0, 0, VRESTOQANTM1),
             VRESTOQANTM2  = Decode(QTESTOQANT, 0, 0, VRESTOQANTM2),
             VRBRUTOANT    = Decode(QTESTOQANT, 0, 0, VRBRUTOANT),
             VRBRUTOANTM1  = Decode(QTESTOQANT, 0, 0, VRBRUTOANTM1),
             VRBRUTOANTM2  = Decode(QTESTOQANT, 0, 0, VRBRUTOANTM2),
             VRCLOGDIAAM1  = Decode(QTESTOQANT, 0, 0, VRCLOGDIAAM1),
             VRCLOGDIAAM2  = Decode(QTESTOQANT, 0, 0, VRCLOGDIAAM2),
             VRSEGUDIAAM1  = Decode(QTESTOQANT, 0, 0, VRSEGUDIAAM1),
             VRSEGUDIAAM2  = Decode(QTESTOQANT, 0, 0, VRSEGUDIAAM2)
         WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)          AND
               (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE)      AND
               (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ)      AND
               (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)        AND
               (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)         AND
               (CDPRODUTO    = C_PRODUTO.CDPRODUTO)         AND
               (QTESTOQDIA   = 0 OR QTESTOQANT = 0)         AND
               (DTPOSIESTQ  >= P_DTINICIAL);

         BEGIN
           SELECT ROUND(NVL(QTESTOQDIA,   0), 5),
                  ROUND(NVL(VRESTOQDIA,   0), 5),
                  ROUND(NVL(VRESTOQBRUT,  0), 5),
                  ROUND(NVL(VRESTOQDIAM1, 0), 5),
                  ROUND(NVL(VRESTOQDIAM2, 0), 5),
                  DTPOSIESTQ,
                  ROUND(NVL(VRCLOGDIA,0),5),
                  ROUND(NVL(VRCLOGDIAM1,0),5),
                  ROUND(NVL(VRCLOGDIAM2,0),5),
                  ROUND(NVL(VRSEGUDIA,0),5),
                  ROUND(NVL(VRSEGUDIAM1,0),5),
                  ROUND(NVL(VRSEGUDIAM2,0),5)
           INTO   V_QTDEESTO,
                  V_VALRESTO,
                  V_VALRBRUT,
                  V_VALRESTOM1,
                  V_VALRESTOM2,
                  V_DTPOSIESTQ,
                  V_VRCUSTOLOG,
                  V_VRCLOGDIAM1,
                  V_VRCLOGDIAM2,
                  V_VRCUSTOSEG,
                  V_VRSEGUDIAM1,
                  V_VRSEGUDIAM2
           FROM POSESTDIA
           WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)        AND
                 (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE)    AND
                 (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ)    AND
                 (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)      AND
                 (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)       AND
                 (CDPRODUTO    = C_PRODUTO.CDPRODUTO)       AND
                 (DTPOSIESTQ   = (SELECT MAX(DTPOSIESTQ)
                                  FROM POSESTDIA
                                  WHERE (CDFILIAL     = C_PRODUTO.CDFILIAL)      AND
                                        (CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE)  AND
                                        (CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ)  AND
                                        (NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ)    AND
                                        (NRSUBLOTE    = C_PRODUTO.NRSUBLOTE)     AND
                                        (CDPRODUTO    = C_PRODUTO.CDPRODUTO)));
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_QTDEESTO    := 0;
              V_VALRESTO    := 0;
              V_VALRBRUT    := 0;
              V_VALRESTOM1  := 0;
              V_VALRESTOM2  := 0;
              V_DTPOSIESTQ  := Null;
              V_VRCUSTOLOG  := 0;
              V_VRCLOGDIAM1 := 0;
              V_VRCLOGDIAM2 := 0;
              V_VRCUSTOSEG  := 0;
              V_VRSEGUDIAM1 := 0;
              V_VRSEGUDIAM2 := 0;

         END;

         IF V_IDESTONEG IS NULL THEN
            IF (V_MOVNEG <> 'S') THEN
               SELECT NVL(SUM(QTRESPRODPED),0)
               INTO V_QTRESPRODPED
               FROM RESERPRODPED
               WHERE CDFILIAL     = C_PRODUTO.CDFILIAL     AND
                     CDPRODUTO    = C_PRODUTO.CDPRODUTO    AND
                     CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE AND
                     CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ AND
                     NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ   AND
                     NRSUBLOTE    = C_PRODUTO.NRSUBLOTE;

               V_QTRESPRODPED := V_QTDEESTO - V_QTRESPRODPED;
               IF V_QTRESPRODPED >= 0 THEN
                  IF (V_QTDEESTO = 0) THEN
                     UPDATE LOTE
                     SET IDSTATLOTE = 'E'
                     WHERE CDFILIAL   = C_PRODUTO.CDFILIAL   AND
                           CDPRODUTO  = C_PRODUTO.CDPRODUTO  AND
                           NRLOTEESTQ = C_PRODUTO.NRLOTEESTQ AND
                           NRSUBLOTE  = C_PRODUTO.NRSUBLOTE;

                     DELETE MOVILOTE
                     WHERE RowId = C_Produto.RowId;

                  ELSIF (V_QTDEESTO > 0) THEN
                     UPDATE LOTE
                     SET IDSTATLOTE = 'L'
                     WHERE CDFILIAL   = C_PRODUTO.CDFILIAL   AND
                           CDPRODUTO  = C_PRODUTO.CDPRODUTO  AND
                           NRLOTEESTQ = C_PRODUTO.NRLOTEESTQ AND
                           NRSUBLOTE  = C_PRODUTO.NRSUBLOTE;

                     DELETE MOVILOTE
                     WHERE RowId = C_Produto.RowId;
                  END IF;
               END IF;
            END IF;
         END IF;

         IF (V_QTDEESTO <> 0) THEN

            UPDATE POSESTATU
            SET QTTOTALESTOQ = V_QTDEESTO,
                VRTOTALESTOQ = V_VALRESTO,
                VRTOTALESTM1 = V_VALRESTOM2,
                VRTOTALESTM2 = V_VALRESTOM2,
                DTULTMOVIMEN = V_DTPOSIESTQ,
                VRCLOGATU    = V_VRCUSTOLOG,
                VRCLOGATUM1  = V_VRCLOGDIAM1,
                VRCLOGATUM2  = V_VRCLOGDIAM2,
                VRSEGUATU    = V_VRCUSTOSEG,
                VRSEGUATUM1  = V_VRSEGUDIAM1,
                VRSEGUATUM2  = V_VRSEGUDIAM2
            WHERE CDFILIAL     = C_PRODUTO.CDFILIAL     AND
                  CDALMOXARIFE = C_PRODUTO.CDALMOXARIFE AND
                  CDLOCALESTOQ = C_PRODUTO.CDLOCALESTOQ AND
                  NRLOTEESTQ   = C_PRODUTO.NRLOTEESTQ   AND
                  NRSUBLOTE    = C_PRODUTO.NRSUBLOTE    AND
                  CDPRODUTO    = C_PRODUTO.CDPRODUTO;

            IF (SQL%ROWCOUNT = 0) THEN
               INSERT INTO POSESTATU
                  (CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                   NRSUBLOTE, QTTOTALESTOQ, VRTOTALESTOQ, DTULTMOVIMEN, VRTOTALESTM1, VRTOTALESTM2,
                   VRCLOGATU, VRCLOGATUM1,VRCLOGATUM2,VRSEGUATU,VRSEGUATUM1,VRSEGUATUM2)
               VALUES
                  (C_PRODUTO.CDFILIAL, C_PRODUTO.CDPRODUTO, C_PRODUTO.CDALMOXARIFE, C_PRODUTO.CDLOCALESTOQ, C_PRODUTO.NRLOTEESTQ,
                   C_PRODUTO.NRSUBLOTE, V_QTDEESTO, V_VALRESTO, V_DTPOSIESTQ, V_VALRESTOM1, V_VALRESTOM2,
                   V_VRCUSTOLOG, V_VRCLOGDIAM1, V_VRCLOGDIAM2, V_VRCUSTOSEG, V_VRSEGUDIAM1, V_VRSEGUDIAM2);
            END IF;
         END IF;
      END LOOP;

      IF (NVL(V_UTILALMO,w_N) = w_S) OR  (NVL(V_UTILLOTE, w_N) = w_S) THEN
         ATUALIZA_ESTOQUE_CONS(P_FILIMOVI, V_CDPRODUTO, P_DTINICIAL, P_DTFINAL);
      ELSE

/*Verifica data para atualziao da POSESTCONS e insere na tabela de lista um registro
  com PRODUTO+DTAINICIAL e outro para PRODUTODATAFINAL para cada produto atualizada*/

         IF P_DTINICIAL+1 < V_DTINICIAL THEN
            V_DTINICIAL := P_DTINICIAL+1;
         END IF;

         IF P_DTFINAL+1 > V_DTFINAL THEN
            V_DTFINAL   := P_DTFINAL+1;
         END IF;

         INSERT INTO LISTA(NRLISTA, CDLISTA)
         (SELECT V_NRLISTADT, LPAD(CDLISTA,10,' ')||TO_CHAR(V_DTINICIAL+1)
          FROM LISTA
          WHERE NRLISTA = V_NRLISTA
          MINUS
          SELECT V_NRLISTADT, CDLISTA
          FROM LISTA
          WHERE NRLISTA = V_NRLISTADT);

         INSERT INTO LISTA(NRLISTA, CDLISTA)
         (SELECT V_NRLISTADT, LPAD(CDLISTA,10,' ')||V_DTFINAL
          FROM LISTA
          WHERE NRLISTA = V_NRLISTA
          MINUS
          SELECT V_NRLISTADT, CDLISTA
          FROM LISTA
          WHERE NRLISTA = V_NRLISTADT);


         V_CDPRODUTO := 'X';
         V_DATAPOS   := TO_DATE('01/01/1900');
  /*Atualizao ESTOQUE CONSOLIDADO para os dias em que h registro de nova posio
    entre o perodo informdo */
         FOR C_POSESTCONS IN (SELECT
                                /*+ INDEX (P PK_POSESTDIA) */
                                P.CDFILIAL,        P.CDPRODUTO,     P.DTPOSIESTQ,
                                SUM(QTESTOQDIA)   AS QTESTOQDIA,    SUM(VRESTOQDIA)   AS VRESTOQDIA,
                                SUM(VRESTOQDIAM1) AS VRESTOQDIAM1,  SUM(VRESTOQDIAM2) AS VRESTOQDIAM2,
                                SUM(QTESTOQANT)   AS QTESTOQANT,    MAX(DTCUSTANT)    AS DTCUSTANT,
                                SUM(VRESTOQANT)   AS VRESTOQANT,    SUM(VRESTOQANTM1) AS VRESTOQANTM1,
                                SUM(VRESTOQANTM2) AS VRESTOQANTM2,  SUM(VRESTOQBRUT)  AS VRESTOQBRUT,
                                SUM(VRESTOQBRUM1) AS VRESTOQBRUM1,  SUM(VRESTOQBRUM2) AS VRESTOQBRUM2,
                                SUM(VRBRUTOANT)   AS VRBRUTOANT,    SUM(VRBRUTOANTM1) AS VRBRUTOANTM1,
                                SUM(VRBRUTOANTM2) AS VRBRUTOANTM2,  MAX(IDPOSIZERO)   AS IDPOSIZERO,
                                SUM(VRCLOGDIA)    AS VRCLOGDIA,     SUM(VRCLOGDIAANT) AS VRCLOGDIAANT,
                                SUM(VRCLOGDIAM1)  AS VRCLOGDIAM1,   SUM(VRCLOGDIAAM1) AS VRCLOGDIAAM1,
                                SUM(VRCLOGDIAM2)  AS VRCLOGDIAM2,   SUM(VRCLOGDIAAM2) AS VRCLOGDIAAM2,
                                SUM(VRSEGUDIA)    AS VRSEGUDIA,     SUM(VRSEGUDIAANT) AS VRSEGUDIAANT,
                                SUM(VRSEGUDIAM1)  AS VRSEGUDIAM1,   SUM(VRSEGUDIAAM1) AS VRSEGUDIAAM1,
                                SUM(VRSEGUDIAM2)  AS VRSEGUDIAM2,   SUM(VRSEGUDIAAM2) AS VRSEGUDIAAM2
                             FROM POSESTDIA P, LISTA
                             WHERE (P.CDFILIAL   = P_FILIMOVI)                      AND
                                   (NRLISTA      = V_NRLISTA)                       AND
                                   (P.CDPRODUTO  = CDLISTA)                         AND
                                   (DTPOSIESTQ BETWEEN V_DTINICIAL AND V_DTFINAL)
                             GROUP BY CDFILIAL, CDPRODUTO, DTPOSIESTQ
                             ORDER BY DTPOSIESTQ, CDPRODUTO) LOOP

            IF (V_CDPRODUTO <> C_POSESTCONS.CDPRODUTO) or (V_DATAPOS <> C_POSESTCONS.DTPOSIESTQ) THEN

               V_CDPRODUTO := C_POSESTCONS.CDPRODUTO;
               V_DATAPOS   := C_POSESTCONS.DTPOSIESTQ;

               /*Retirada DIA/PRODUTO da lista de dias-produtos a atualizar*/
               DELETE FROM LISTA
               WHERE NRLISTA = V_NRLISTADT   AND
                     CDLISTA = LPAD(C_POSESTCONS.CDPRODUTO, 10, ' ')||C_POSESTCONS.DTPOSIESTQ;

            END IF;

            /*Atualizao POSESTCONS com a soma da POSESTDIA*/
            UPDATE POSESTCONS
            SET QTESTDIACON   =   C_POSESTCONS.QTESTOQDIA,
                VRESTDIACON   =   C_POSESTCONS.VRESTOQDIA,
                VRESTDIACOM1  =   C_POSESTCONS.VRESTOQDIAM1,
                VRESTDIACOM2  =   C_POSESTCONS.VRESTOQDIAM2,
                QTESTANTCON   =   C_POSESTCONS.QTESTOQANT,
                DTCUSTANTCON  =   C_POSESTCONS.DTCUSTANT,
                VRESTANTCON   =   C_POSESTCONS.VRESTOQANT,
                VRESTANTCOM1  =   C_POSESTCONS.VRESTOQANTM1,
                VRESTANTCOM2  =   C_POSESTCONS.VRESTOQANTM2,
                VRESTBRUTCON  =   C_POSESTCONS.VRESTOQBRUT,
                VRESTBRUTCM1  =   C_POSESTCONS.VRESTOQBRUM1,
                VRESTBRUTCM2  =   C_POSESTCONS.VRESTOQBRUM2,
                VRBRUTANTCON  =   C_POSESTCONS.VRBRUTOANT,
                VRBRUTANTCM1  =   C_POSESTCONS.VRBRUTOANTM1,
                VRBRUTANTCM2  =   C_POSESTCONS.VRBRUTOANTM2,
                IDPOSZEROCON  =   C_POSESTCONS.IDPOSIZERO,
                VRCLOGCON     =   C_POSESTCONS.VRCLOGDIA,
                VRCLOGCONANT  =   C_POSESTCONS.VRCLOGDIAANT,
                VRCLOGCONM1   =   C_POSESTCONS.VRCLOGDIAM1,
                VRCLOGCONAM1  =   C_POSESTCONS.VRCLOGDIAAM1,
                VRCLOGCONM2   =   C_POSESTCONS.VRCLOGDIAM2,
                VRCLOGCONAM2  =   C_POSESTCONS.VRCLOGDIAAM2,
                VRSEGUCON     =   C_POSESTCONS.VRSEGUDIA,
                VRSEGUCONANT  =   C_POSESTCONS.VRSEGUDIAANT,
                VRSEGUCONM1   =   C_POSESTCONS.VRSEGUDIAM1,
                VRSEGUCONAM1  =   C_POSESTCONS.VRSEGUDIAAM1,
                VRSEGUCONM2   =   C_POSESTCONS.VRSEGUDIAM2,
                VRSEGUCONAM2  =   C_POSESTCONS.VRSEGUDIAAM2
            WHERE (CDFILIAL    = P_FILIMOVI)                 AND
                  (CDPRODUTO   = C_POSESTCONS.CDPRODUTO)     AND
                  (DTPOSESTCON = C_POSESTCONS.DTPOSIESTQ);

            IF SQL%ROWCOUNT = 0 THEN
               /*Se antes da atualizao no havia registro na POSESTCONS realiza incluso */
               INSERT INTO POSESTCONS
                  (CDFILIAL,     CDPRODUTO,    DTPOSESTCON,  QTESTDIACON,  VRESTDIACON,  VRESTDIACOM1,
                   VRESTDIACOM2, QTESTANTCON,  DTCUSTANTCON, VRESTANTCON,  VRESTANTCOM1, VRESTANTCOM2, VRESTBRUTCON,
                   VRESTBRUTCM1, VRESTBRUTCM2, VRBRUTANTCON, VRBRUTANTCM1, VRBRUTANTCM2, IDPOSZEROCON,
                   VRCLOGCON,    VRCLOGCONANT, VRCLOGCONM1,  VRCLOGCONAM1, VRCLOGCONM2,  VRCLOGCONAM2,
                   VRSEGUCON,    VRSEGUCONANT, VRSEGUCONM1,  VRSEGUCONAM1, VRSEGUCONM2,  VRSEGUCONAM2)
               VALUES
                  (C_POSESTCONS.CDFILIAL,     C_POSESTCONS.CDPRODUTO,    C_POSESTCONS.DTPOSIESTQ,
                   C_POSESTCONS.QTESTOQDIA,   C_POSESTCONS.VRESTOQDIA,   C_POSESTCONS.VRESTOQDIAM1,
                   C_POSESTCONS.VRESTOQDIAM2, C_POSESTCONS.QTESTOQANT,   C_POSESTCONS.DTCUSTANT,
                   C_POSESTCONS.VRESTOQANT,   C_POSESTCONS.VRESTOQANTM1, C_POSESTCONS.VRESTOQANTM2,
                   C_POSESTCONS.VRESTOQBRUT,  C_POSESTCONS.VRESTOQBRUM1, C_POSESTCONS.VRESTOQBRUM2,
                   C_POSESTCONS.VRBRUTOANT,   C_POSESTCONS.VRBRUTOANTM1, C_POSESTCONS.VRBRUTOANTM2,
                   C_POSESTCONS.IDPOSIZERO,   C_POSESTCONS.VRCLOGDIA,    C_POSESTCONS.VRCLOGDIAANT,
                   C_POSESTCONS.VRCLOGDIAM1,  C_POSESTCONS.VRCLOGDIAAM1, C_POSESTCONS.VRCLOGDIAM2,
                   C_POSESTCONS.VRCLOGDIAAM2, C_POSESTCONS.VRSEGUDIA,    C_POSESTCONS.VRSEGUDIAANT,
                   C_POSESTCONS.VRSEGUDIAM1,  C_POSESTCONS.VRSEGUDIAAM1, C_POSESTCONS.VRSEGUDIAM2,
                   C_POSESTCONS.VRSEGUDIAAM2);

            END IF;
         END LOOP;

         /*Apaga da tabela POSESTCONS os dias-produto que com a atualizao passaram
          a no possuir registro na POSESTDIA (Ex.: alterao ou excluso de uma lanamento
          de estoque em data que no exista outro lanamento para o produto)*/
         FOR C_LISTA IN (SELECT LTRIM(SUBSTR(CDLISTA,1,10))   AS CDPRODUTO,
                               TO_DATE(SUBSTR(CDLISTA,11,20)) AS DTPOSESTPROD
                        FROM LISTA
                        WHERE NRLISTA = V_NRLISTADT     and
                              not LTRIM(SUBSTR(CDLISTA,11,20)) is null) LOOP
           SELECT MAX(DTULTMOVIMEN)
           INTO V_DTULTMOVIMEN
           FROM POSESTATU
           WHERE (CDFILIAL  = P_FILIMOVI)              AND
                 (CDPRODUTO = C_LISTA.CDPRODUTO);

           DELETE POSESTCONS
           WHERE CDFILIAL     = P_FILIMOVI                  AND
                 CDPRODUTO    = C_LISTA.CDPRODUTO           AND
                 (DTPOSESTCON = C_LISTA.DTPOSESTPROD OR
                  DTPOSESTCON > V_DTULTMOVIMEN);
         END LOOP;


/*Limpa listas geradas*/
         DELETE LISTA
         WHERE NRLISTA = V_NRLISTA;

         DELETE LISTA
         WHERE NRLISTA = V_NRLISTADT;
      END IF;
   END;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_ESTOQUE_REC','5.01.010'); END;
/

