/* Sistemas Integrados TEKNISA

Nome: 5099_DFESTPS_ARREDONDA_BASECALC.SQL

Descrio:
Procedure para arredondar o valor da base de clculo de acordo com o valor contabil

Criao:
03/10/2005 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'ARREDONDA_BASECALC'  and
            type   = 'P'                   and
            u.uid  = o.uid                 and
            u.name = USER)
  DROP PROCEDURE ARREDONDA_BASECALC
  GO

CREATE PROCEDURE ARREDONDA_BASECALC
                 @P_IDENTRSAID  VARCHAR(01),
                 @P_FILIAL      VARCHAR(04),
                 @P_LANCTONF    VARCHAR(10)
AS
   DECLARE @V_VRDIFERENCA   DOUBLE PRECISION;
   DECLARE @V_VRCONTIMPOIT  DOUBLE PRECISION;
   DECLARE @V_VRBCALCIMPOIT DOUBLE PRECISION;
   DECLARE @V_VRBASECALCIT  DOUBLE PRECISION;

   DECLARE @V_ITEMPROD_CDIMPOSTO     VARCHAR(02);
   DECLARE @V_ITEMPROD_NRSEQITPROD   VARCHAR(04);
   DECLARE @V_ITEMPROD_VRCONTIMPOIT  DOUBLE PRECISION;

   DECLARE @V_ITPROIMPOS_CDIMPOSTO   VARCHAR(02);
   DECLARE @V_ITPROIMPOS_NRSEQITPROD VARCHAR(04);
   DECLARE @V_ITPROIMPOS_VRCONTITIMP DOUBLE PRECISION;
BEGIN
   SET @V_VRBCALCIMPOIT = 0;
   SET @V_VRBASECALCIT  = 0;

   IF @P_IDENTRSAID = 'E' BEGIN
      DECLARE C_ITEMPRODUTO CURSOR FOR
         SELECT T.CDIMPOSTOIT AS CDIMPOSTO, I.NRSEQITPROD, MAX(ISNULL(VRCONTIMPOIT,0)) AS VRCONTIMPOIT
         FROM ITEMPRODUTO I, TRABITPROIMPOS T
         WHERE CDFILIAL     = @P_FILIAL     AND
               NRLANCTONF   = @P_LANCTONF   AND
               CDFILIMPOIT  = I.CDFILIAL    AND
               NRLANCIMPOIT = I.NRLANCTONF  AND
               NRSEQIMPOIT  = I.NRSEQITPROD AND
               NRSEQITPRO   = '1'
         GROUP BY T.CDIMPOSTOIT, I.NRSEQITPROD;
      OPEN C_ITEMPRODUTO;
      FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPROD_CDIMPOSTO, @V_ITEMPROD_NRSEQITPROD,
                                         @V_ITEMPROD_VRCONTIMPOIT;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @V_ITEMPROD_VRCONTIMPOIT <> 0 BEGIN
            UPDATE TRABITPROIMPOS
            SET VRBCALCIMPOIT  = ROUND(VRBCALCIMPOIT,2)
            WHERE CDFILIMPOIT  = @P_FILIAL                  AND
                  NRLANCIMPOIT = @P_LANCTONF                AND
                  NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD    AND
                  CDIMPOSTOIT  = @V_ITEMPROD_CDIMPOSTO      AND
                  NRSEQITPRO   = '1';

            SELECT @V_VRBCALCIMPOIT = MAX(ISNULL(VRBCALCIMPOIT,0))
            FROM TRABITPROIMPOS
            WHERE CDFILIMPOIT  = @P_FILIAL                  AND
                  NRLANCIMPOIT = @P_LANCTONF                AND
                  NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD    AND
                  CDIMPOSTOIT  = @V_ITEMPROD_CDIMPOSTO      AND
                  NRSEQITPRO   = '1';

            SET @V_VRDIFERENCA = (@V_ITEMPROD_VRCONTIMPOIT - @V_VRBCALCIMPOIT);

            IF (@V_VRDIFERENCA <> 0) AND (ABS(@V_VRDIFERENCA) < 0.03) BEGIN
               UPDATE TRABITPROIMPOS
               SET VRBCALCIMPOIT  = (VRBCALCIMPOIT + @V_VRDIFERENCA)
               WHERE CDFILIMPOIT  = @P_FILIAL                  AND
                     NRLANCIMPOIT = @P_LANCTONF                AND
                     NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD    AND
                     CDIMPOSTOIT  = @V_ITEMPROD_CDIMPOSTO      AND
                     NRSEQITPRO   = '1';
            END;
         END;

         FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPROD_CDIMPOSTO, @V_ITEMPROD_NRSEQITPROD,
                                            @V_ITEMPROD_VRCONTIMPOIT;
      END;
      CLOSE C_ITEMPRODUTO;
      DEALLOCATE C_ITEMPRODUTO;
   END;

   DECLARE C_ITEMPROIMPOS CURSOR FOR
      SELECT T.CDIMPOSTO, I.NRSEQITPROD, MAX(ISNULL(VRCONTITIMP,0)) AS VRCONTITIMP
      FROM ITEMPRODUTO I, ITEMPROIMPOS T
      WHERE I.CDFILIAL     = @P_FILIAL       AND
            I.NRLANCTONF   = @P_LANCTONF     AND
            T.CDFILIAL     = I.CDFILIAL      AND
            T.NRLANCTONF   = I.NRLANCTONF    AND
            T.NRSEQITPROD  = I.NRSEQITPROD  AND
            T.NRITPROIMPOS = '1'
      GROUP BY T.CDIMPOSTO, I.NRSEQITPROD;

   OPEN C_ITEMPROIMPOS;
   FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_ITPROIMPOS_CDIMPOSTO, @V_ITPROIMPOS_NRSEQITPROD,
                                       @V_ITPROIMPOS_VRCONTITIMP;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ITPROIMPOS_VRCONTITIMP <> 0 BEGIN
         UPDATE ITEMPROIMPOS
         SET VRBASECALCIT = ROUND(VRBASECALCIT,2)
         WHERE (NRLANCTONF   = @P_LANCTONF) AND
               (CDFILIAL     = @P_FILIAL)   AND
               (NRSEQITPROD  = @V_ITPROIMPOS_NRSEQITPROD) AND
               (CDIMPOSTO    = @V_ITPROIMPOS_CDIMPOSTO)   AND
               (NRITPROIMPOS = '1');

         SELECT @V_VRBASECALCIT = MAX(ISNULL(VRBASECALCIT,0))
         FROM ITEMPROIMPOS
         WHERE (NRLANCTONF   = @P_LANCTONF) AND
               (CDFILIAL     = @P_FILIAL)   AND
               (NRSEQITPROD  = @V_ITPROIMPOS_NRSEQITPROD) AND
               (CDIMPOSTO    = @V_ITPROIMPOS_CDIMPOSTO)   AND
               (NRITPROIMPOS = '1');

         SET @V_VRDIFERENCA = (@V_ITPROIMPOS_VRCONTITIMP - @V_VRBASECALCIT);

         IF (@V_VRDIFERENCA <> 0) AND (ABS(@V_VRDIFERENCA) < 0.03) BEGIN
            UPDATE ITEMPROIMPOS
            SET VRBASECALCIT  = (VRBASECALCIT + @V_VRDIFERENCA)
            WHERE (NRLANCTONF   = @P_LANCTONF) AND
                  (CDFILIAL     = @P_FILIAL)   AND
                  (NRSEQITPROD  = @V_ITPROIMPOS_NRSEQITPROD) AND
                  (CDIMPOSTO    = @V_ITPROIMPOS_CDIMPOSTO)   AND
                  (NRITPROIMPOS = '1');
         END;
      END;
--      OPEN C_ITEMPROIMPOS;
      FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_ITPROIMPOS_CDIMPOSTO, @V_ITPROIMPOS_NRSEQITPROD,
                                          @V_ITPROIMPOS_VRCONTITIMP;
   END;
   CLOSE C_ITEMPROIMPOS;
   DEALLOCATE C_ITEMPROIMPOS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ARREDONDA_BASECALC','5.05.020';
GO
