/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_INSPECAO                                                 */
/* Tabela : INSPECAO                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 18/02/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_INSPECAO
BEFORE INSERT OR UPDATE OR DELETE
ON INSPECAO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUINSP:= SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDINSPECAO,0)   <> NVL(:NEW.CDINSPECAO,0))   OR
         (NVL(:OLD.CDARVINSPEC,0)  <> NVL(:NEW.CDARVINSPEC,0))  OR
         (NVL(:OLD.NMINSPECAO,0)   <> NVL(:NEW.NMINSPECAO,0))   OR
         (NVL(:OLD.CDNVINSPECAO,0) <> NVL(:NEW.CDNVINSPECAO,0)) OR
         (NVL(:OLD.IDORIGINSPEC,0) <> NVL(:NEW.IDORIGINSPEC,0)) THEN
         :NEW.DTULTATUINSP:= SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('INSPECAO', '', 'CDNVINSPECAO='||:OLD.CDNVINSPECAO||';CDARVINSPEC='||:OLD.CDARVINSPEC||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE INSPECAO MODIFY DTULTATUINSP DEFAULT SYSDATE
/
