<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Entities;

use Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Calendar\EntityCalendarUserInterface;
use Zeedhi\DevOps\Util\Events\Audit_with_id\AuditAble;
use Zeedhi\DevOps\Util\Events\Organization_with_id\OrganizationAble;


class Resource extends \Zeedhi\DevOps\Model\Projectmanagement\Entities\Base\Resource
    implements AuditAble, OrganizationAble, EntityCalendarUserInterface {

    const WORK_RESOURCE = 'W';
    const ASSET_RESOURCE = 'A';
    const COST_RESOURCE = 'D';
    const CONTACT_RESOURCE = 'C';

    const CLASS_SPONSOR = 'S';
    const CLASS_EMPLOYEE = 'E';
    const CLASS_CONTACT = 'C';
    const CLASS_ASSET = 'A';
    const CLASS_COST = 'D';

    const IS_USER_TRUE = 'Y';
    const IS_USER_FALSE = 'N';

    const IS_ACTIVE = 'A';
    const IS_INACTIVE = 'I';
    const IS_DELETED = 'D';

    public function getAllCalendars() {
        return $this->getParentsCalendar();
    }
    public function getParentsCalendar() {
        $permissions = $this->getPermissions();
        $calendar = array($this->getCalendar());
        if (!empty($permissions)) {
            foreach ($permissions as $permission) {
                if($permission->getType() != 'M'){
                    $calendar = array_merge($calendar, $permission->getStructure()->getAllCalendar());
                }
            }
        }
        return $calendar;
    }
}