<?php

namespace Zeedhi\Zmart\Util;


class ComparisonExpression {

    const EQ          = "==";
    const NEQ         = "!=";
    const LT          = "<";
    const LTE         = "<=";
    const GT          = ">";
    const GTE         = ">=";

    protected $firstValue;
    protected $operator;
    protected $secondValue;

    public function __construct($firstValue, $operator, $secondValue) {
        $this->firstValue = $firstValue;
        $this->operator = $operator;
        $this->secondValue = $secondValue;
    }

    /**
     * @return MathExpression|int|string
     */
    public function getFirstValue() {
        return $this->firstValue;
    }

    /**
     * @return string
     */
    public function getOperator() {
        return $this->operator;
    }

    /**
     * @return MathExpression|int|string
     */
    public function getSecondValue() {
        return $this->secondValue;
    }

    /**
     * @param MathExpression|int|string $firstValue
     */
    public function setFirstValue($firstValue) {
        $this->firstValue = $firstValue;
    }

    /**
     * @param string $operator
     */
    public function setOperator($operator) {
        $this->operator = $operator;
    }

    /**
     * @param MathExpression|int|string $secondValue
     */
    public function setSecondValue($secondValue) {
        $this->secondValue = $secondValue;
    }
}